]> git.street.me.uk Git - andy/dehydrated.git/blame - test.sh
format CA certificate as PEM
[andy/dehydrated.git] / test.sh
CommitLineData
a4e7c43a
LS
1#!/bin/bash
2
3# Fail early
4set -eu -o pipefail
5
6# Check if running in CI environment
7if [[ ! "${CI:-false}" == "true" ]]; then
8 echo "ERROR: Not running in CI environment!"
9 exit 1
10fi
11
12_TEST() {
d3bc67eb 13 echo
40556950
LS
14 echo "${1} "
15}
16_SUBTEST() {
17 echo -n " + ${1} "
a4e7c43a
LS
18}
19_PASS() {
98fe9b34
LS
20 if [[ ! -z "$(cat errorlog)" ]]; then
21 _FAIL
22 fi
40556950 23 echo -e "[\u001B[32mPASS\u001B[0m]"
a4e7c43a
LS
24}
25_FAIL() {
26 echo -e "[\u001B[31mFAIL\u001B[0m]"
27 echo
28 echo "Problem: ${@}"
29 echo
30 echo "STDOUT:"
31 cat tmplog
32 echo
33 echo "STDERR:"
34 cat errorlog
35 exit 1
36}
37_CHECK_FILE() {
d3bc67eb 38 _SUBTEST "Checking if file '${1}' exists..."
40556950
LS
39 if [[ -e "${1}" ]]; then
40 _PASS
41 else
42 _FAIL "Missing file: ${1}"
43 fi
a4e7c43a
LS
44}
45_CHECK_LOG() {
d3bc67eb 46 _SUBTEST "Checking if log contains '${1}'..."
40556950
LS
47 if grep -- "${1}" tmplog > /dev/null; then
48 _PASS
49 else
50 _FAIL "Missing in log: ${1}"
51 fi
52}
341f5252 53_CHECK_NOT_LOG() {
d3bc67eb 54 _SUBTEST "Checking if log doesn't contain '${1}'..."
341f5252
LS
55 if grep -- "${1}" tmplog > /dev/null; then
56 _FAIL "Found in log: ${1}"
57 else
58 _PASS
59 fi
60}
40556950
LS
61_CHECK_ERRORLOG() {
62 _SUBTEST "Checking if errorlog is empty..."
63 if [[ -z "$(cat errorlog)" ]]; then
64 _PASS
65 else
66 _FAIL "Non-empty errorlog"
67 fi
a4e7c43a
LS
68}
69
70# If not found (should be cached in travis) download ngrok
71if [[ ! -e "ngrok/ngrok" ]]; then
72 (
73 mkdir -p ngrok
74 cd ngrog
75 wget https://dl.ngrok.com/ngrok_2.0.19_linux_amd64.zip -O ngrok.zip
76 unzip ngrok.zip ngrok
77 chmod +x ngrok
78 )
79fi
80
81# Run ngrok and grab temporary url from logfile
82ngrok/ngrok http 8080 --log stdout --log-format logfmt --log-level debug > tmp.log &
83sleep 2
84TMP_URL="$(grep -Eo "Hostname:[a-z0-9]+.ngrok.io" tmp.log | head -1 | cut -d':' -f2)"
85if [[ -z "${TMP_URL}" ]]; then
86 echo "Couldn't get an url from ngrok, not a letsencrypt.sh bug, tests can't continue."
87 exit 1
88fi
89
90# Run python webserver in .acme-challenges directory to serve challenge responses
91mkdir -p .acme-challenges/.well-known/acme-challenge
92(
93 cd .acme-challenges
94 python -m SimpleHTTPServer 8080 > /dev/null 2> /dev/null
95) &
96
97# Generate config and create empty domains.txt
f6f77139
LS
98echo 'CA="https://testca.kurz.pw/directory"' > config.sh
99echo 'LICENSE="https://testca.kurz.pw/terms/v1"' >> config.sh
a4e7c43a
LS
100echo 'WELLKNOWN=".acme-challenges/.well-known/acme-challenge"' >> config.sh
101touch domains.txt
102
103# Check if help command is working
104_TEST "Checking if help command is working..."
6a8f4482 105./letsencrypt.sh --help > tmplog 2> errorlog || _FAIL "Script execution failed"
a4e7c43a 106_CHECK_LOG "Default command: help"
40556950
LS
107_CHECK_LOG "--help (-h)"
108_CHECK_LOG "--domain (-d) domain.tld"
109_CHECK_ERRORLOG
a4e7c43a
LS
110
111# Run in cron mode with empty domains.txt (should only generate private key and exit)
112_TEST "First run in cron mode, checking if private key is generated and registered"
6a8f4482 113./letsencrypt.sh --cron > tmplog 2> errorlog || _FAIL "Script execution failed"
a4e7c43a
LS
114_CHECK_LOG "Registering account key"
115_CHECK_FILE "private_key.pem"
40556950 116_CHECK_ERRORLOG
a4e7c43a
LS
117
118# Temporarily move config out of the way and try signing certificate by using temporary config location
119_TEST "Try signing using temporary config location and with domain as command line parameter"
120mv config.sh tmp_config.sh
d1d9d1f6 121./letsencrypt.sh --cron --domain "${TMP_URL}" -f tmp_config.sh > tmplog 2> errorlog || _FAIL "Script execution failed"
6a8f4482 122_CHECK_NOT_LOG "Checking domain name(s) of existing cert"
a4e7c43a
LS
123_CHECK_LOG "Generating private key"
124_CHECK_LOG "Requesting challenge for ${TMP_URL}"
125_CHECK_LOG "Challenge is valid!"
126_CHECK_LOG "Creating fullchain.pem"
127_CHECK_LOG "Done!"
40556950 128_CHECK_ERRORLOG
a4e7c43a
LS
129mv tmp_config.sh config.sh
130
131# Move private key and add new location to config
132mv private_key.pem account_key.pem
133echo 'PRIVATE_KEY="./account_key.pem"' >> config.sh
134
135# Add domain to domains.txt and run in cron mode again (should find a non-expiring certificate and do nothing)
136_TEST "Run in cron mode again, this time with domain in domains.txt, should find non-expiring certificate"
137echo "${TMP_URL}" >> domains.txt
6a8f4482
LS
138./letsencrypt.sh --cron > tmplog 2> errorlog || _FAIL "Script execution failed"
139_CHECK_LOG "Checking domain name(s) of existing cert... unchanged."
a4e7c43a 140_CHECK_LOG "Skipping!"
40556950 141_CHECK_ERRORLOG
a4e7c43a 142
341f5252
LS
143# Run in cron mode one last time, with domain in domains.txt and force-resign (should find certificate, resign anyway, and not generate private key)
144_TEST "Run in cron mode one last time, with domain in domains.txt and force-resign"
145echo "${TMP_URL}" >> domains.txt
6a8f4482
LS
146./letsencrypt.sh --cron --force > tmplog 2> errorlog || _FAIL "Script execution failed"
147_CHECK_LOG "Checking domain name(s) of existing cert... unchanged."
2d097c92 148_CHECK_LOG "Ignoring because renew was forced!"
341f5252
LS
149_CHECK_NOT_LOG "Generating private key"
150_CHECK_LOG "Requesting challenge for ${TMP_URL}"
151_CHECK_LOG "Challenge is valid!"
152_CHECK_LOG "Creating fullchain.pem"
153_CHECK_LOG "Done!"
154_CHECK_ERRORLOG
155
a4e7c43a
LS
156# Delete account key (not needed anymore)
157rm account_key.pem
158
85b3f191
LS
159# Check if renewal works
160_TEST "Run in cron mode again, to check if renewal works"
161echo 'RENEW_DAYS="300"' >> config.sh
162./letsencrypt.sh --cron > tmplog 2> errorlog || _FAIL "Script execution failed"
163_CHECK_LOG "Checking domain name(s) of existing cert... unchanged."
164_CHECK_LOG "Renewing!"
165_CHECK_ERRORLOG
166
a4e7c43a
LS
167# Check if certificate is valid in various ways
168_TEST "Verifying certificate..."
d3bc67eb
LS
169_SUBTEST "Verifying certificate on its own..."
170openssl x509 -in "certs/${TMP_URL}/cert.pem" -noout -text > tmplog 2> errorlog && _PASS || _FAIL
a4e7c43a 171_CHECK_LOG "CN=${TMP_URL}"
d3bc67eb
LS
172_SUBTEST "Verifying file with full chain..."
173openssl x509 -in "certs/${TMP_URL}/fullchain.pem" -noout -text > /dev/null 2>> errorlog && _PASS || _FAIL
174_SUBTEST "Verifying certificate against CA certificate..."
175(openssl verify -verbose -CAfile "certs/${TMP_URL}/fullchain.pem" -purpose sslserver "certs/${TMP_URL}/fullchain.pem" 2>&1 || true) | (grep -v ': OK$' || true) >> errorlog 2>> errorlog && _PASS || _FAIL
40556950 176_CHECK_ERRORLOG
a4e7c43a
LS
177
178# Revoke certificate using certificate key
179_TEST "Revoking certificate..."
6a8f4482 180./letsencrypt.sh --revoke "certs/${TMP_URL}/cert.pem" --privkey "certs/${TMP_URL}/privkey.pem" > tmplog 2> errorlog || _FAIL "Script execution failed"
a4e7c43a
LS
181_CHECK_LOG "Revoking certs/${TMP_URL}/cert.pem"
182_CHECK_LOG "SUCCESS"
183_CHECK_FILE "certs/${TMP_URL}/cert.pem-revoked"
40556950 184_CHECK_ERRORLOG
a4e7c43a
LS
185
186# All done
187exit 0